=== debian/changelog ===
colmap (3.8-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright:
    - bump years.
    - drop flann and graclus parts.
  * d/control: add libflann-dev and libsqlite3-dev to build-depends.

 -- Gürkan Myczko <tar@debian.org>  Wed, 01 Feb 2023 07:59:00 +0100
